Attribute VB_Name = "modCapture"
Option Explicit

Private Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)

Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long

Public Sub makeScreenshot(Optional ByVal ActiveWindow As Boolean = False)
  Const KEYEVENTF_KEYUP = &H2
  Const VK_MENU = &H12
  Const VK_SNAPSHOT = &H2C

  If ActiveWindow Then keybd_event VK_MENU, 0, 0, 0   'ALT-Taste
  keybd_event VK_SNAPSHOT, 0, 0, 0                    'Druck-Taste
  keybd_event VK_SNAPSHOT, 0, KEYEVENTF_KEYUP, 0
  If ActiveWindow Then keybd_event VK_MENU, 0, KEYEVENTF_KEYUP, 0
  DoEvents
End Sub

Public Sub showPicture(picContainer As Object, pic As StdPicture)
  Dim picWidth As Long
  Dim picHeight As Long
  Dim picLeft As Long
  Dim picTop As Long
  Dim contAspectRatio As Single
  Dim picAspectRatio As Single
  
  On Local Error Resume Next
  With picContainer
    contAspectRatio = .ScaleWidth / .ScaleHeight
    ' Bild-Gre + Gren-Verhltnis
    picWidth = .ScaleX(pic.Width, vbHimetric, .ScaleMode)
    picHeight = .ScaleY(pic.Height, vbHimetric, .ScaleMode)
    picAspectRatio = picWidth / picHeight
    ' Bild anpassen?
    If (picWidth > .ScaleWidth Or picHeight > .ScaleHeight) Then
      If picAspectRatio <= contAspectRatio Then
        ' Bildbreite muss angepasst werden
        picWidth = picWidth / (picHeight / .ScaleHeight)
        picHeight = .ScaleHeight
      Else
        ' Bildhhe muss angepasst werden
        picHeight = picHeight / (picWidth / .ScaleWidth)
        picWidth = .ScaleWidth
      End If
    End If
    ' Bild zentrieren
    picLeft = (.ScaleWidth - picWidth) \ 2
    picTop = (.ScaleHeight - picHeight) \ 2
    ' Bild zeichnen
    Set .Picture = Nothing
    .AutoRedraw = True
    .PaintPicture pic, picLeft, picTop, picWidth, picHeight
    Set .Picture = .Image
    .AutoRedraw = False
  End With
End Sub

